/*
	BromScript - On Runtime Scripting Language.
    Copyright (C) 2012 - 2013  Alex Brouwer (Bromvlieg: http://brom.4o3.nl/)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "BromScriptDllTest.h"
#include <BromScript.h>

using namespace BromScript;

#define DLL_EXPORT extern "C" __declspec(dllexport)
DLL_EXPORT BS_MODULE(BromScriptStart){
	Variable* msg = Converter::ToVariable("The dll got loaded, WARGGGGGG!");
	bsi->GC.RegisterVariable(msg);

    List<Variable*> args;
    args.Add(msg);
    ((Function*)bsi->GetVar("print")->Value)->Run(&args);
}

DLL_EXPORT BS_MODULE(BromScriptShutdown){ 
    Variable* msg = Converter::ToVariable("The bsi instance is being destroyed, noooooooo!");
	bsi->GC.RegisterVariable(msg);

    List<Variable*> args; 
    args.Add(msg); 
    ((Function*)bsi->GetVar("print")->Value)->Run(&args);
} 